<script setup lang="ts">
import { provide } from 'vue';
import { type Ref, inject, ref } from 'vue';


const rail = inject<Ref<boolean>>('rail');
const showDialog = ref(false);
const form = ref(false);
const email = ref(null);
const password = ref(null);
const loading = ref(false);
const users = ref<Array<{ id: number; email: string; password: string; fullname: string; gender: string; roles: string[]; }>>([]);
const signedInUserInfo = ref(null);
const showUserInfoDialog = ref(false);
const Emaildialogwrong = ref(false);


provide(signedInUserInfo,'signedInUserInfo')


function initialize() {
  users.value = [
    {
      id: 1,
      email: 'admin@admin.com',
      password: 'admin123',
      fullname: 'Admin',
      gender: 'male',
      roles: ['admin', 'user']
    },
    {
      id: 2,
      email: 'user1@user.com',
      password: 'user12231',
      fullname: 'User1',
      gender: 'female',
      roles: ['user']
    },
    {
      id: 3,
      email: 'user2@user.com',
      password: 'Pasord123',
      fullname: 'User2',
      gender: 'male',
      roles: ['user']
    },
    {
        id: 4,
        email: 'p@p.com',
        password: 'pp',
        fullname: 'พีช',
        gender: 'male',
        roles: ['user']
    }
  ];
}

initialize();

const onSubmit = async () => {
  if (!form.value) return;
  loading.value = true;
  try {
    const isValid = await checkCredentials(email.value, password.value);

    if (isValid) {
      // Find the user information based on email and password
      const user = users.value.find(user => user.email === email.value && user.password === password.value);

      // Store signed-in user information
      signedInUserInfo.value = user;

      // Show user info dialog
      showUserInfoDialog.value = true;

      // Reset form and close login dialog
      form.value = false;
      email.value = null;
      password.value = null;
      showDialog.value = false;
    } else {
      console.error("รหัสผ่านไม่ถูกต้อง");
    }
  } catch (error) {
    console.error("An error occurred during Sign In:", error);
  } finally {
    loading.value = false;
  }
};

const required = (v) => !!v || 'Field is required';

const checkCredentials = async (email, password) => {
  await new Promise(resolve => setTimeout(resolve, 2000));

  // ตรวจสอบ email และ password จากข้อมูลใน users
  const isValid = users.value.some(user => user.email === email && user.password === password);

  if (!isValid) {
    Emaildialogwrong.value = true; // Set the error dialog to true
  }

  return isValid;
};
</script>

<style scoped>
.custom-bg-color {
  background-color: rgb(165, 132, 107);
}
</style>

<template>
  <v-app-bar color="teal-darken-4" image="https://images-ext-1.discordapp.net/external/U3HI0Bg9h1nRestU2OxiiUutRVEvItF03PiUs4pPw6g/https/i.pinimg.com/originals/99/cd/09/99cd0925c516b5d0a740dffd03c3e0df.gif?width=1148&height=502">
    <template v-slot:prepend>
      <v-app-bar-nav-icon @click.stop="rail = !rail"></v-app-bar-nav-icon>
    </template>

    <v-app-bar-title>D-COFFEE</v-app-bar-title>

    <v-spacer></v-spacer>

    <v-btn variant="elevated" @click="showDialog = true" style="background-color: rgb(235, 180, 108);">
      Login
    </v-btn>
    <v-dialog v-model="showDialog" max-width="600">
      <v-card>
        <v-sheet class="custom-bg-color pa-12" rounded>
          <v-card class="mx-auto px-6 py-8" max-width="344">
            <v-form v-model="form" @submit.prevent="onSubmit">
              <v-text-field v-model="email" :readonly="loading" :rules="[required]" class="mb-2" clearable
                label="Email"></v-text-field>
              <v-text-field v-model="password" :readonly="loading" :rules="[required]" clearable label="Password"
                placeholder="Enter your password"></v-text-field>
              <br>
              <v-btn :disabled="!form" :loading="loading" block color="success" size="large" type="submit"
                variant="elevated">
                Sign In
              </v-btn>
            </v-form>
          </v-card>
        </v-sheet>
      </v-card>
    </v-dialog>

    <v-dialog v-model="Emaildialogwrong" width="auto">
      <v-card>
        <v-card-text>
          รหัสผ่านไม่ถูกต้อง
        </v-card-text>
        <v-card-actions>
          <v-btn color="primary" block @click="Emaildialogwrong = false">Close Dialog</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-app-bar>

  <!-- ตรวจสอบว่าผู้ใช้เข้าสู่ระบบหรือไม่ -->
  <div v-if="signedInUserInfo">
    <!-- แสดงชื่อผู้ใช้งานระบบ -->
    <v-dialog v-model="showUserInfoDialog" width="auto">
      <v-card>
        <v-card-text>
          <p>ยินดีต้อนรับคุณ: {{ signedInUserInfo.fullname }} เข้าสู่ระบบ</p>
        </v-card-text>
        <v-card-actions>
          <v-btn color="primary" block @click="showUserInfoDialog = false">Close Dialog</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>
<script>

</script>
